/*
 * RHQ Management Platform
 * Copyright (C) 2005-2010 Red Hat, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation, and/or the GNU Lesser
 * General Public License, version 2.1, also as published by the Free
 * Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License and the GNU Lesser General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * and the GNU Lesser General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package org.rhq.coregui.client.inventory.resource.detail.inventory;

import java.util.Collection;

import com.smartgwt.client.types.Overflow;
import com.smartgwt.client.widgets.grid.ListGridRecord;

import org.rhq.core.domain.resource.group.ResourceGroup;
import org.rhq.coregui.client.inventory.groups.ResourceGroupsDataSource;
import org.rhq.coregui.client.inventory.resource.selection.ResourceGroupSelector;

/**
 * @author Jay Shaughnessy
 */
public class ResourceResourceGroupSelector extends ResourceGroupSelector {

    public ResourceResourceGroupSelector(Collection<ResourceGroup> resourceGroups) {

        super();

        if (null != resourceGroups) {
            ListGridRecord[] data = (new ResourceGroupsDataSource()).buildRecords(resourceGroups);
            setAssigned(data);
        }

        this.setOverflow(Overflow.AUTO);
    }

}
